<?php

namespace Drupal\webpay;

interface WebpayNormalServiceInterface {

  const STATUS_INITIALIZED = 'INITIALIZED';
  const STATUS_AUTHORIZED = 'AUTHORIZED';
  const STATUS_REVERSED = 'REVERSED';
  const STATUS_FAILED = 'FAILED';
  const STATUS_NULLIFIED = 'NULLIFIED';
  const STATUS_PARTIALLY_NULLIFIED = 'PARTIALLY_NULLIFIED';
  const STATUS_CAPTURED = 'CAPTURED';

  const USER_ABORTED_PAYMENT = 'aborted';

  const SOME_ERROR_ON_WEBPAY = 'some_error';

  const USER_WAS_IDLE = 'user_was_idle';

  const IS_NOT_A_NORMAL_RESPONSE = 'is_invalid';

  /**
   * Execute the initTransaction Services.
   *
   * @param int $buyOrder
   * @param float $amount
   * @param string $return_url
   * @param mixed $session
   *
   * @return FALSE|\Transbank\Webpay\WebpayPlus\Responses\TransactionCreateResponse
   */
  public function initTransaction($buyOrder, $amount, $return_url, $instanceId, $session = NULL);

  /**
   * @return bool
   */
  public function isValidRequest();

  /**
   * @return bool
   */
  public function isInvalidRequest();
}
